/*
 * This file is part of the coreboot project.
 *
 * Copyright (C) 2008 Urbez Santana <urbez@linuxupc.upc.edu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#include <stdio.h>

int main(int argc,char **argv)
{
  FILE *r,*w;
  int len;
  int off;
  int i;
  unsigned char buf[8];
  if (argc<3)
  {
    printf("Usage ./gendsdt /proc/acpi/dsdt dsdt.c\n");
    return 0;
  }
  r=fopen(argv[1],"rb");
  if (!r) {printf("Could not open %s\n",argv[1]);return 0;}
  w=fopen(argv[2],"wb");
  if (!w) {printf("Could not write %s\n",argv[2]);return 0;}
  fprintf(w,"/* Intel ACPI Component Architecture\n"
            " * File generated by gendsdt\n"
            " * The content of this file is the intellectual property of its \n"
            " * respective owner.\n"
            " * Do not distribute without the permission of the copyright holder.\n"
            " */\n\n\n");
  fprintf(w,"unsigned char AmlCode[] =\n{\n");
  off=0;
  while(!feof(r))
  {
    len=fread(buf,1,8,r);
    if (len<=0) break;
    fprintf(w,"    ");
    for (i=0;i<len;i++) fprintf(w,"0x%02x,",(int)buf[i]);
    fprintf(w,"  /*  %08x    \"",off);
    for (i=0;i<len;i++) fprintf(w,"%c",(buf[i]>=32 && buf[i]<127)?buf[i]:'.');    
    fprintf(w,"\" */\n");
    off+=len;
  }
  fprintf(w,"};\n");
  fclose(w);
  fclose(r);
}
